#include <stdlib.h>
#include <reent.h>
#include <sys/stat.h>
#include "dbgu.h"

int _isatty(int file)
{
	return 1;
}


_ssize_t _read_r(
    struct _reent *r, 
    int file, 
    void *ptr, 
    size_t len)
{
	unsigned char *p;
	p = ptr;
	*p = debug_waitkey();
	debug_chr(*p);	//echo
	return 1;
}


_ssize_t _write_r (
    struct _reent *r, 
    int file, 
    const void *ptr, 
    size_t len)
{
	int i;
	const unsigned char *p;
	
	p = (const unsigned char*) ptr;
	
	for (i = 0; i < len; i++) {
		debug_chr(*p++);
	}
	
	return len;
}


int _close_r(
    struct _reent *r, 
    int file)
{
	return 0;
}


_off_t _lseek_r(
    struct _reent *r, 
    int file, 
    _off_t ptr, 
    int dir)
{
	return (_off_t)0;	/*  Always indicate we are at file beginning.  */
}


int _fstat_r(
    struct _reent *r, 
    int file, 
    struct stat *st)
{
	/*  Always set as character device.				*/
	st->st_mode = S_IFCHR;
	/* assigned to strong type with implicit 	*/
	/* signed/unsigned conversion.  Required by 	*/
	/* newlib.					*/

	return 0;
}


int isatty(int file); /* avoid warning */

int isatty(int file)
{
	return 1;
}


#if 0
static void _exit (int n) {
label:  goto label; /* endless loop */
}
#endif 

/*
dummy function for heap mgmt -- modify it or just don't use malloc ;)
*/

#define HEAP_SIZE	10

static char _heap[HEAP_SIZE];

static char *heap_ptr;		/* Points to current end of the heap.	*/

void * _sbrk_r(
    struct _reent *_s_r, 
    ptrdiff_t nbytes)
{
	char  *base;

	if (!heap_ptr) {	/*  Initialize if first time through.  */
		heap_ptr = _heap;
	}
	
	base = heap_ptr;	/*  Point to end of heap.  */
	
	heap_ptr += nbytes;	/*  Increase heap.  */
	
	return base;		/*  Return pointer to start of new heap area.  */
}

void abort(void)
{
  while(1);
}
