#ifndef __SPP_CFG_H__
#define __SPP_CFG_H__

#include "leds.h"

extern volatile uint8_t sppAddress;

#define SPP_ADDRESS				sppAddress

#define SPP_PAYLOAD_LEN			40

#define SPP_IGNORE_CRC			0	//debug only

#define SPP_DOUBLE_RX_BUFFER	1

#define SPP_IDLE_TIMEOUT		100

//leave empty - already implemented in spp_stm32.h
#define SPP_DIR_RX				
#define SPP_DIR_TX				
#define SPP_DIR_INIT			

#define SPP_LED_BUSY_ON			led2(1)
#define SPP_LED_BUSY_OFF		led2(0)
#define SPP_LED_BUSY_INIT		


#endif

